#include "Bombe.h"
#include "ddutil.h"
#include "ddstuff.h"
#include "son.h"
#include "Reseau.h"

ListeBombe *lst = NULL;


void CreateBmbSurface(LPDIRECTDRAWSURFACE &lpDDSSpr)
{
	DDSURFACEDESC ddsd;

    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	ddsd.dwWidth = DALLEX;
	ddsd.dwHeight = DALLEY;
    lpDD->CreateSurface(&ddsd, &lpDDSSpr, NULL);
}

ListeBombe::ListeBombe()
{
	liste = NULL;
	LPDIRECTDRAWSURFACE tmp = NULL;

	tmp = DDLoadBitmap(lpDD, BOMBEF, 0, 0);
	if (tmp)
	{
		for (int i = 0; i < NBSPR; i++)
		{
			RECT r;
			r.left = i * (DALLEX+1);
			r.top = 0;
			r.right = (i+1) * (DALLEX+1) - 1;
			r.bottom = DALLEY ;
			lpDDSBombe[i] = NULL;
			CreateBmbSurface(lpDDSBombe[i]);
			if (lpDDSBombe[i])
			{
				lpDDSBombe[i]->BltFast(0,0, tmp, &r, 0);
				DDSetColorKey(lpDDSBombe[i], COLORKEY);
			}
		}
		tmp->Release();
		tmp = NULL;
	}
}


ListeBombe::~ListeBombe()
{
	pbombe temp;

	while(liste)
	{
		temp=liste;
		liste=liste->suiv;
		delete temp;
	}

	if (lpDDSBombe[0])
		lpDDSBombe[0]->Release();
}

void ListeBombe::AddBombe(Joueur *j)
{
	pbombe temp;

	temp = new bombe;
	temp->x=(j->x>>8)/DALLEX;
	temp->y=(j->y>>8)/DALLEY;
	Carte[temp->x][temp->y] &= ~TRAVERSABLE;
	Carte[temp->x][temp->y] |= BOMBE;
	Carte[temp->x][temp->y] &= 0x00FFFFFF;
	temp->proprio=DWORD(j->n) <<24;
	Carte[temp->x][temp->y] |= temp->proprio;

	temp->p = j;
	temp->lg_flamme=j->lg_flamme;
	temp->temps=TMP_BOMBE;
	temp->explose=0;
	temp->numanim = 0;
	for (int i = 0; i < NBSPR ; i++)
		temp->delai[i] = TMP_BOMBE / NBSPR;

	temp->prec=NULL;
	temp->suiv=liste;
	if (liste)
		liste->prec=temp;
	liste=temp;
	if (temp->p->isLocal)
		SendBombe (temp);
}

void ListeBombe::AddBombe(bombe *b)
{
	pbombe temp;

	temp = new bombe;
	temp->x=b->x;
	temp->y=b->y;
	Carte[temp->x][temp->y] &= ~TRAVERSABLE;
	Carte[temp->x][temp->y] |= BOMBE;
	Carte[temp->x][temp->y] &= 0x00FFFFFF;
	temp->proprio=b->proprio;
	Carte[temp->x][temp->y] |= temp->proprio;

	temp->p = j[DWORD(b->proprio) >>24];
	temp->lg_flamme=b->lg_flamme;
	temp->temps=TMP_BOMBE;
	temp->explose=0;
	temp->numanim = 0;
	for (int i = 0; i < NBSPR ; i++)
		temp->delai[i] = TMP_BOMBE / NBSPR;

	temp->prec=NULL;
	temp->suiv=liste;
	if (liste)
		liste->prec=temp;
	liste=temp;
}

int Explosex(pbombe tmp, int i)
{
	if (Carte[tmp->x+i][tmp->y] & (TRAVERSABLE | BOMBE))
	{
		Carte[tmp->x+i][tmp->y] |= FLAMMEH;
		Carte[tmp->x+i][tmp->y] &= 0x00FFFFFF;
		Carte[tmp->x+i][tmp->y] |= tmp->proprio;
		Carte[tmp->x+i][tmp->y] &= ~(FLAMMEV | FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
		if (Carte[tmp->x+i][tmp->y] & (BOMBESUP | BOMBEINF | SPEEDUP | SPEEDDOWN | FLAMMEUP | FLAMMEDOWN))
		{
			Carte[tmp->x+i][tmp->y] &= ~(BOMBESUP | BOMBEINF | SPEEDUP | SPEEDDOWN | FLAMMEUP | FLAMMEDOWN);
			return 1;
		}
		return 0;
	}
	if (Carte[tmp->x+i][tmp->y] & DESTRUCTIBLE)
	{
		Carte[tmp->x+i][tmp->y] |= FLAMMEH;
		Carte[tmp->x+i][tmp->y] &= 0x00FFFFFF;
		Carte[tmp->x+i][tmp->y] |= tmp->proprio;
		Carte[tmp->x+i][tmp->y] &= ~DESTRUCTIBLE;
		Carte[tmp->x+i][tmp->y] |= TRAVERSABLE;
	}
	return 1;
}

int Explosey(pbombe tmp, int i)
{
	if (Carte[tmp->x][tmp->y+i] & (TRAVERSABLE | BOMBE))
	{
		Carte[tmp->x][tmp->y+i] |= FLAMMEV;
		Carte[tmp->x][tmp->y+i] &= 0x00FFFFFF;
		Carte[tmp->x][tmp->y+i] |= tmp->proprio;

		Carte[tmp->x][tmp->y+i] &= ~(FLAMMEH | FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
		if (Carte[tmp->x][tmp->y+i] & (BOMBESUP | BOMBEINF | SPEEDUP | SPEEDDOWN | FLAMMEUP | FLAMMEDOWN))
		{
			Carte[tmp->x][tmp->y+i] &= ~(BOMBESUP | BOMBEINF | SPEEDUP | SPEEDDOWN | FLAMMEUP | FLAMMEDOWN);
			return 1;
		}
		return 0;
	}
	if (Carte[tmp->x][tmp->y+i] & DESTRUCTIBLE)
	{
		Carte[tmp->x][tmp->y+i] |= FLAMMEV;
		Carte[tmp->x][tmp->y+i] &= 0x00FFFFFF;
		Carte[tmp->x][tmp->y+i] |= tmp->proprio;
		Carte[tmp->x][tmp->y+i] &= ~DESTRUCTIBLE;
		Carte[tmp->x][tmp->y+i] |= TRAVERSABLE;
	}
	return 1;
}

void ListeBombe::Update(int t)
{
	pbombe tmp = liste;

	while (tmp)
	{
		if (!tmp->explose && (Carte[tmp->x][tmp->y] & (FLAMMEV | FLAMMEH | FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB | FERMETURE)))
			tmp->temps = -1;
		tmp->delai[tmp->numanim] -=t;
		if (tmp->delai[tmp->numanim] < 0 && tmp->numanim < NBSPR - 1)
			tmp->numanim++;
		tmp->temps -= t;
		if (tmp->temps < 0)			
		{
			if (!tmp->explose)
			{
				PlayEvent (BOMBEEXPLO);
				Carte[tmp->x][tmp->y] &= ~(FLAMMEV | FLAMMEH | FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
				Carte[tmp->x][tmp->y] |= FLAMMEH;
				int i;
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (Explosex(tmp, i))
						i = tmp->lg_flamme + 5;
				if (i != tmp->lg_flamme + 6)
				{
					Carte[tmp->x+tmp->lg_flamme][tmp->y] &= ~(FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
					Carte[tmp->x+tmp->lg_flamme][tmp->y] |= FLAMMEFIND;
				}
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (Explosex(tmp, -i))
						i = tmp->lg_flamme + 5;
				if (i != tmp->lg_flamme + 6)
				{
					Carte[tmp->x-tmp->lg_flamme][tmp->y] &= ~(FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
					Carte[tmp->x-tmp->lg_flamme][tmp->y] |= FLAMMEFING;
				}
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (Explosey(tmp, i))
						i = tmp->lg_flamme + 5;
				if (i != tmp->lg_flamme + 6)
				{
					Carte[tmp->x][tmp->y+tmp->lg_flamme] &= ~(FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
					Carte[tmp->x][tmp->y+tmp->lg_flamme] |= FLAMMEFINB;
				}
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (Explosey(tmp, -i))
						i = tmp->lg_flamme + 5;
				if (i != tmp->lg_flamme + 6)
				{
					Carte[tmp->x][tmp->y-tmp->lg_flamme] &= ~(FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
					Carte[tmp->x][tmp->y-tmp->lg_flamme] |= FLAMMEFINH;
				}

				tmp->explose = 1;
				tmp->temps = TMP_FLAMME;
				tmp->p->nb_bombe_posee--;
				tmp = tmp->suiv;
			}
			else
			{

				Carte[tmp->x][tmp->y] &= ~(FLAMMEV | FLAMMEH | FLAMMEH | FLAMMEFING | FLAMMEFIND | FLAMMEFINH | FLAMMEFINB);
				int i;
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (tmp->x + i < NBDALLEX)
						Carte[tmp->x+i][tmp->y] &= ~(FLAMMEH | FLAMMEFIND);
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (tmp->x - i > 0)
						Carte[tmp->x-i][tmp->y] &= ~(FLAMMEH | FLAMMEFING);
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (tmp->y + i < NBDALLEY)
						Carte[tmp->x][tmp->y+i] &= ~(FLAMMEV | FLAMMEFINB);
				for (i = 1; i < tmp->lg_flamme + 1 ; i++)
					if (tmp->y - i > 0)
						Carte[tmp->x][tmp->y-i] &= ~(FLAMMEV | FLAMMEFINH);

				tmp->p->nb_bombe_jeu--;
				tmp = DelBombe(tmp);
			}
		}
		else
			tmp = tmp->suiv;
	}
}

void ListeBombe::Aff()
{
	pbombe tmp = liste;

	while (tmp && !tmp->explose)
	{
		lpDDSBack->BltFast(tmp->x*DALLEX, tmp->y*DALLEY, lpDDSBombe[tmp->numanim], NULL, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		tmp = tmp->suiv;
	}
}


pbombe ListeBombe::DelBombe(pbombe bombe)
{
	pbombe temp;
	Carte[bombe->x][bombe->y] |= TRAVERSABLE;
	Carte[bombe->x][bombe->y] &= ~BOMBE;
	if (bombe->prec)
	{
		temp=bombe->prec;
		temp->suiv=temp->suiv->suiv;
		if (temp->suiv)
			temp->suiv->prec=temp;
		delete bombe;
		return temp->suiv;
	}
	else
	{
		liste = liste->suiv;
		if (liste)
			liste->prec = NULL;
		delete bombe;
		return liste;
	}
}