#define WIN32_LEAN_AND_MEAN
// Obligatoire pour utiliser DirectPlay 3
#define IDIRECTPLAY2_OR_GREATER
// Obligatoire pour utiliser QueryInterface

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include "resource.h"
#include "main.h"
#include "ddstuff.h"
#include "joueur.h"
#include "dplay.h"
#include "setup.h"
#include "reseau.h"
#include "keyb.h"
#include "bombe.h"
#include "reseau.h"

LPDIRECTPLAY3       lpDP            = NULL;
DPSESSIONDESC2      dpDesc;
LPDPSESSIONDESC2    lpdpDesc        = NULL;
DPCAPS              dpCaps;
HANDLE              hPlayerEvent    = NULL;
HANDLE              hKillEvent      = NULL;
HANDLE              hReceiveThread  = NULL;
DWORD               idReceiveThread = 0;
DWORD               dwExpression;
LPVOID              lpReceiveBuffer = NULL;
DWORD               dwReceiveBufferSize = 0;
bool                bEnumerating = FALSE;
bool                bUserCancel = TRUE;

#define TIMER_ID        1
#define TIMER_RATE      500

GUID BOMBERMAN_GUID = {
    0x949a21e1,
    0x6179,
    0x11cf,
    {0x95, 0x4f, 0x00, 0xaa, 0x00, 0x6c, 0x26, 0x59}
};

void EvaluateChatterMessage( DPMSG_GENERIC *pGeneric, DPID pidFrom, HWND hWnd );
BOOL WINAPI EnumConnection( LPCGUID lpguidSP,LPVOID lpConnection, DWORD dwSize,LPDPNAME lpName, DWORD dwFlags,LPVOID lpContext )
{
    LONG            iIndex;
    HWND hWnd       = ( HWND ) lpContext;
    LPVOID          lpOurConnection = NULL;
    LPDIRECTPLAY3   lpDPTemp;

    // Vrifie si on peut initialiser une connexion.
    if FAILED( CoCreateInstance( CLSID_DirectPlay,NULL, CLSCTX_ALL, IID_IDirectPlay3A,( LPVOID* ) &lpDPTemp ) )
        return FALSE;

    if FAILED( lpDPTemp->InitializeConnection( lpConnection, 0 ) )
    {
        lpDPTemp->Release();
        return TRUE;
    }
    lpDPTemp->Release();

    // Si initialisation, l'ajoute  la liste.
    iIndex = SendMessage( hWnd, CB_ADDSTRING, 0, (LPARAM) lpName->lpszShortNameA );

    // Si ajout  la liste, cre un duplicata de la connexion
    // et mmorise dans la liste un pointeur vers celui-ci.
    if (iIndex == LB_ERR)
        return FALSE;

	lpOurConnection = malloc( dwSize );
    if ( !lpOurConnection )
		return FALSE;
    memcpy( lpOurConnection, lpConnection, dwSize );
    SendMessage( hWnd, CB_SETITEMDATA, iIndex, ( LPARAM ) lpOurConnection );

    return TRUE;
}

BOOL WINAPI EnumSession( LPDPSESSIONDESC2 lpDPGameDesc, LPDWORD lpdwTimeOut,DWORD dwFlags, LPVOID lpContext )
{
    LONG iIndex;
    HWND hWnd = ( HWND ) lpContext;
    LPGUID lpGuid;

    // Commence par vrifier si l'numration a dpass le dlai. Si oui,
    // nous pourrions la rinitialiser mais nous nous contenterons de l'annuler.

    if( dwFlags & DPESC_TIMEDOUT )
        return FALSE;

    iIndex = SendMessage( hWnd, LB_ADDSTRING, 0, (LPARAM) lpDPGameDesc->lpszSessionName );

    // Si ajout  la liste, cre un duplicata du GUID
    // et mmorise dans la liste un pointeur vers celui-ci.

    if ( iIndex != LB_ERR )
    {
        lpGuid = ( LPGUID ) malloc( sizeof( GUID ) );
        if ( !lpGuid ) return FALSE;

        *lpGuid = lpDPGameDesc->guidInstance;

        SendMessage( hWnd, LB_SETITEMDATA, iIndex, ( LPARAM ) lpGuid );
    }

    return(TRUE);
}

BOOL CALLBACK DlgProcDPStart( HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam )
{
    long                i;
    LPVOID              lpHeap, lpConnection;
    DWORD               dwSessions;
    LPDELETEITEMSTRUCT  lpdis;
    char                szSessionName[30];
    LPGUID              lpGuid;
    HRESULT             hr;

    switch( message )
    {
        case WM_INITDIALOG:
            CoInitialize( NULL );   // exig par CoCreateInstance

            if FAILED( CoCreateInstance( CLSID_DirectPlay,NULL, CLSCTX_ALL, IID_IDirectPlay3A,( LPVOID* ) &lpDP ) )
            {
                MessageBox( hWnd, "Erreur de cration objet DirectPlay !", "Erreur", MB_OK );
                EndDialog( hWnd, FALSE );
            }
            
            i = SendDlgItemMessage( hWnd, IDC_CONNECTIONS, CB_ADDSTRING, 0, (LPARAM) "<<Slectionner une connexion>>" );
            SendDlgItemMessage( hWnd, IDC_CONNECTIONS, CB_SETITEMDATA, i, ( LPARAM ) NULL );

            if FAILED( lpDP->EnumConnections( NULL, ( LPDPENUMCONNECTIONSCALLBACK )EnumConnection,( LPVOID )GetDlgItem( hWnd, IDC_CONNECTIONS ),0 ) )
            {
                MessageBox( hWnd, "Impossible d'numrer connexions !","Erreur", MB_OK );
                EndDialog( hWnd, FALSE );
            }
            else
                SendDlgItemMessage( hWnd, IDC_CONNECTIONS, CB_SETCURSEL, 0, 0L );

            // Cre un vnement, qui sera utilis pour signaler que
            // le joueur a des messages.

            hPlayerEvent = CreateEvent( NULL, FALSE, FALSE, NULL );

            // Lance un timer pour liste des sessions asynchrones.
            SetTimer( hWnd, TIMER_ID, TIMER_RATE, NULL );

            return TRUE;

        case WM_DELETEITEM:
            // Supprime la mmoire alloue quand la liste et le combo
            // sont remplis.
            lpdis = ( LPDELETEITEMSTRUCT ) lParam;
            lpHeap = ( LPVOID )lpdis->itemData;
            if ( lpHeap )
                free( lpHeap );
            return TRUE;

        case WM_COMMAND:         
            switch( LOWORD( wParam ) )
            {
                case IDC_CONNECTIONS:
                    switch (HIWORD(wParam))
                    {
                        case CBN_SELCHANGE:                        
                            // Obtient la connexion slectionne dans 
                            // la liste.
                            i = SendDlgItemMessage( hWnd, IDC_CONNECTIONS, CB_GETCURSEL,0, 0L );
                            lpConnection = ( LPVOID )SendDlgItemMessage( hWnd, IDC_CONNECTIONS, CB_GETITEMDATA,i, 0 );
                            if ( lpConnection == NULL ) return TRUE;

                            // Libre l'objet DP existant, afin que nous puissions 
                            // le rinitialiser avec la connexion slectionne.

                            lpDP->Release();

                            if FAILED( CoCreateInstance( CLSID_DirectPlay,NULL, CLSCTX_ALL, IID_IDirectPlay3A,( LPVOID* ) &lpDP) )
                            {
                                MessageBox( hWnd, "Erreur de cration objet DirectPlay !","Erreur", MB_OK );
                                return TRUE;
                            }
                            
                            if FAILED( lpDP->InitializeConnection( lpConnection, 0 ) )
                            {
                                MessageBox( hWnd, "Erreur d'initialisation objet DirectPlay !","Erreur", MB_OK );
                                EnableWindow( GetDlgItem( hWnd, IDCREATE ),FALSE );
                                EnableWindow( GetDlgItem( hWnd, IDJOIN ),FALSE );
                                bUserCancel = TRUE;
                            }
                            else
                            {
                                EnableWindow( GetDlgItem( hWnd, IDCREATE ),TRUE );
                                bUserCancel = FALSE;
                            }
                            return TRUE;
                    }
                    return TRUE;

                case IDJOIN:
                    i = SendDlgItemMessage( hWnd, IDC_SESSIONS, LB_GETCURSEL, 0, 0L );
                    lpGuid = ( LPGUID )SendDlgItemMessage( hWnd,IDC_SESSIONS, LB_GETITEMDATA, i, 0 );

                    ZeroMemory( &dpDesc, sizeof( dpDesc ) );
                    dpDesc.dwSize = sizeof( dpDesc );
                    dpDesc.guidInstance = *lpGuid;
                    dpDesc.guidApplication = BOMBERMAN_GUID;

                    if FAILED( lpDP->Open( &dpDesc, DPOPEN_JOIN ) )
                    {         
                        MessageBox( hWnd, "Impossible de rejoindre session !", "Erreur", MB_OK );
                        EndDialog( hWnd, FALSE );
                    }
                    EndDialog( hWnd, TRUE );
                    return TRUE;

                case IDCREATE:
                    // Cre la session avec les paramtres saisis.
                    GetDlgItemText( hWnd, IDC_SESSIONNAME, szSessionName, 30 );

                    ZeroMemory( &dpDesc, sizeof( dpDesc ) );
                    dpDesc.dwSize = sizeof( dpDesc );
                    dpDesc.guidApplication = BOMBERMAN_GUID;
                    dpDesc.dwFlags = 0;//DPSESSION_MIGRATEHOST | DPSESSION_KEEPALIVE;
                    dpDesc.lpszSessionNameA = szSessionName;

                    if FAILED( lpDP->Open( &dpDesc, DPOPEN_CREATE ) )
                    {         
                        MessageBox( hWnd, "Impossible de crer session !", "Erreur", MB_OK );
                        EndDialog( hWnd, FALSE );
                    }
                    EndDialog( hWnd, TRUE );
                    return TRUE;

                case IDCANCEL:
                    EndDialog( hWnd, FALSE );
                    return TRUE;
            }
            break;

        case WM_TIMER:
			{
            if ( bEnumerating || bUserCancel ) return TRUE;

            if ( !lpDP ) return TRUE;

            // Affiche la liste courante des sessions, s'il
            // y a un objet DPlay valide.

			int oldpos = SendDlgItemMessage( hWnd, IDC_SESSIONS, LB_GETCURSEL, 0, 0 );
            SendDlgItemMessage(hWnd, IDC_SESSIONS, LB_RESETCONTENT, 0, 0L);

            ZeroMemory( &dpDesc, sizeof( dpDesc ) );
            dpDesc.dwSize = sizeof( dpDesc );
            dpDesc.guidApplication = BOMBERMAN_GUID;

            dwSessions = DPENUMSESSIONS_AVAILABLE | DPENUMSESSIONS_ASYNC;

            bEnumerating = TRUE;

            // Lance l'numration.
            hr = lpDP->EnumSessions( &dpDesc, 0, ( LPDPENUMSESSIONSCALLBACK2 )EnumSession, ( LPVOID ) GetDlgItem( hWnd, IDC_SESSIONS ), dwSessions );
            
            if ( hr == DPERR_USERCANCEL )
                bUserCancel = TRUE;

            bEnumerating = FALSE;

            // Ajuste l'interface s'il existe des sessions
            // disponibles.
            if ( SendDlgItemMessage( hWnd, IDC_SESSIONS, LB_GETCOUNT, 0, 0 ) > 0 )
            {
                EnableWindow( GetDlgItem( hWnd, IDJOIN ),TRUE );
                SendDlgItemMessage( hWnd, IDC_SESSIONS, LB_SETCURSEL, (WPARAM) oldpos, 0 );
            }
            else
                EnableWindow( GetDlgItem( hWnd, IDJOIN ), FALSE );
            return TRUE;
			}       
        case WM_DESTROY:
            KillTimer( hWnd, TIMER_ID );
            break;
    }
    return FALSE; 
}

void EvaluateSystemMessage( DPMSG_GENERIC *pGeneric, HWND hWnd )
{    
    switch( pGeneric->dwType )
    {
        // Le message arrive, converti en DPMSG_GENERIC.  On examine
        // dwType pour dterminer le type du message ; ensuite, on convertit
    	// vers le type et on value le reste du message.

        case DPSYS_CREATEPLAYERORGROUP:
        {
            DPMSG_CREATEPLAYERORGROUP *pMsg;
            pMsg = ( DPMSG_CREATEPLAYERORGROUP * )pGeneric;

            // Ajoute le joueur  la liste des destinataires
            // possibles pour les messages.
            ChatterAddPlayer( pMsg->dpnName.lpszShortNameA, pMsg->dpId, hWnd );
            break;
        }

        case DPSYS_DESTROYPLAYERORGROUP:
        {
            DPMSG_DESTROYPLAYERORGROUP *pMsg;
            pMsg = ( DPMSG_DESTROYPLAYERORGROUP * )pGeneric;

            // Supprime le joueur de la liste des destinataires
            // possibles pour les messages.
            ChatterDeletePlayer( pMsg->dpnName.lpszShortNameA,pMsg->dpId, hWnd );
            break;
        }

        case DPSYS_SESSIONLOST:
        {
            MessageBox( hWnd, "Contact avec la session perdu !","Erreur", MB_OK );
            break;
        }
    }      
}

void ReceiveMessages( HWND hWnd )
{
    DPID            fromID;
    DPID            toID;
    DWORD           nBytes;
    DPMSG_GENERIC   *pGeneric;
    HRESULT         dprval;

    // On n'utilise pas directement la valeur globale,
    // car la fonction la modifie.
    nBytes = dwReceiveBufferSize;

    while ( TRUE )
    {   
		toID = dpPlayerID[0];
        dprval = lpDP->Receive( &fromID, &toID, DPRECEIVE_TOPLAYER, lpReceiveBuffer, &nBytes );

        if ( dprval == DPERR_BUFFERTOOSMALL )
        // Il faut ajuster la taille du tampon de rception.
        {
            if ( lpReceiveBuffer == NULL)
            {
                // On n'a pas encore allou de tampon ; on le fait.
                lpReceiveBuffer = malloc( nBytes );
                if ( lpReceiveBuffer == NULL ) 
				{
                    OutputDebugString( "Impossible d'allouer la mmoire !\n" );
                    return;
                }
            }
            else
            {
                // Le tampon a t allou, mais il est trop petit
                // donc il faut l'agrandir.
                GlobalFreePtr( lpReceiveBuffer );
                lpReceiveBuffer = malloc( nBytes );
                if ( lpReceiveBuffer == NULL ) {
                    OutputDebugString( "Impossible d'allouer la mmoire !\n" );
                    return;
                }
            }
            // Actualise notre variable globale en y mettant la nouvelle taille du tampon.
            dwReceiveBufferSize = nBytes;
        }
        else if ( dprval == DP_OK )
        // Un message a t reu avec succs.
        {   
            pGeneric = ( DPMSG_GENERIC * )lpReceiveBuffer;

            if ( fromID == DPID_SYSMSG )
                EvaluateSystemMessage ( pGeneric, hWnd );
            else
				if (fromID != dpPlayerID[0])
					EvaluateChatterMessage( pGeneric, fromID, hWnd );
        }
        else
            return;
    }
}

DWORD WINAPI ReceiveThread( LPVOID lpParameter )
{
    HWND        hWnd = ( HWND )lpParameter;
    HANDLE      eventHandles[2];
    eventHandles[0] = hPlayerEvent;
    eventHandles[1] = hKillEvent;

    // Attend que se dclenche l'vnement joueur ou kill.
    // Si c'est l'vnement joueur (WAIT_OBJECT_0), on traite les messages
    // et on attend  nouveau. Si c'est l'vnement kill, on arrte le
    // thread et on sort.

    while ( WaitForMultipleObjects( 2, eventHandles, FALSE,INFINITE ) == WAIT_OBJECT_0 )
        ReceiveMessages( hWnd );

    ExitThread( 0 );

    return 0;
}

