#include "reseau.h"
#include "joueur.h"
#include "keyb.h"
#include "ia.h"


HANDLE		hIAThread  = NULL;
DWORD		idIAThread = 0;
HANDLE      IAeventHandles[NUM_IA_EVENT];
bool		IA_is_waiting = true;

void IA ()
{
	static DWORD last_t = GetTickCount ();
	DWORD cur_t = GetTickCount ();
	if (cur_t - last_t == 0)
		return;
	IA_is_waiting = false;
	for (int i = 0 ; i < nbj ; i++)
		if (j[i] && !j[i]->isHumain)
			j[i]->IA (cur_t - last_t);
	last_t = cur_t;
	IA_is_waiting = true;
}

DWORD WINAPI IAThread( LPVOID lpParameter )
{
	bool	go = false;

    while (1)
	{
		DWORD r = WaitForMultipleObjects( NUM_IA_EVENT, IAeventHandles, FALSE,INFINITE );
		if (r == WAIT_OBJECT_0)
			break;
		if (r == WAIT_OBJECT_0+1)
			go = true;
		if (r == WAIT_OBJECT_0+2)
			go = false;
		if (r == WAIT_OBJECT_0+3 && go)
			IA ();
	}

    ExitThread( 0 );

    return 0;
}

bool InitIAThread ()
{
	for (int i = 0 ; i < NUM_IA_EVENT ; i++)
		IAeventHandles[i] = CreateEvent( NULL, FALSE, FALSE, NULL );
	hIAThread = CreateThread( NULL,0,IAThread,NULL,0,&idIAThread );
//	SetThreadPriority (hIAThread, THREAD_PRIORITY_BELOW_NORMAL);
	return hIAThread != NULL;
}

void CloseIAThread ()
{
	if (!hIAThread)
		return;
	SetEvent (IAeventHandles[IA_EVENT_QUIT]);
	WaitForSingleObject( hIAThread, INFINITE );
	for (int i = 0 ; i < NUM_IA_EVENT ; i++)
	{
		CloseHandle (IAeventHandles[i]);
		IAeventHandles[i] = NULL;
	}
	hIAThread = NULL;
}

char Joueur::FindDir (char bombe[NBDALLEX][NBDALLEY], DWORD t, bStopFind *f, void *p, bool FindClosest, int toX, int toY)
{
	int dist[NBDALLEX][NBDALLEY];
	char dir [NBDALLEX][NBDALLEY];
	bool change = false;
	int x = posjx2posc(this->x), y = posjy2posc(this->y);
	bool isOnBombe = bombe[x][y]!=0;
	int min = (toX - x)*(toX - x)+(toY - y)*(toY - y), mindir = IMMOBILE;
	FillMemory (&dist[0][0], sizeof(int)*NBDALLEX*NBDALLEY, 0x01);
	dist[x][y] = 0;
	dir[x][y] = IMMOBILE;

	if (isOnBombe)
	{
		if (Carte[x-1][y] & TRAVERSABLE)
		{
			dist[x-1][y] = 1;
			dir[x-1][y] = GAUCHE;
			change = true;
		}
		if (Carte[x+1][y] & TRAVERSABLE)
		{
			dist[x+1][y] = 1;
			dir[x+1][y] = DROITE;
			change = true;
		}
		if (Carte[x][y-1] & TRAVERSABLE)
		{
			dist[x][y-1] = 1;
			dir[x][y-1] = HAUT;
			change = true;
		}
		if (Carte[x][y+1] & TRAVERSABLE)
		{
			dist[x][y+1] = 1;
			dir[x][y+1] = BAS;
			change = true;
		}
	}
	else
	{
		if (!bombe[x-1][y] && (Carte[x-1][y] & TRAVERSABLE))
		{
			dist[x-1][y] = 1;
			dir[x-1][y] = GAUCHE;
			change = true;
			if (FindClosest)
			{
				int m = (toX - (x-1))*(toX - (x-1))+(toY - y)*(toY - y);
				if (m < min)
				{
					min = m;
					mindir = GAUCHE;
				}
			}
		}
		if (!bombe[x+1][y] && (Carte[x+1][y] & TRAVERSABLE))
		{
			dist[x+1][y] = 1;
			dir[x+1][y] = DROITE;
			change = true;
			if (FindClosest)
			{
				int m = (toX - (x+1))*(toX - (x+1))+(toY - y)*(toY - y);
				if (m < min)
				{
					min = m;
					mindir = DROITE;
				}
			}
		}
		if (!bombe[x][y-1] && (Carte[x][y-1] & TRAVERSABLE))
		{
			dist[x][y-1] = 1;
			dir[x][y-1] = HAUT;
			change = true;
			if (FindClosest)
			{
				int m = (toX - x)*(toX - x)+(toY - (y-1))*(toY - (y-1));
				if (m < min)
				{
					min = m;
					mindir = HAUT;
				}
			}
		}
		if (!bombe[x][y+1] && (Carte[x][y+1] & TRAVERSABLE))
		{
			dist[x][y+1] = 1;
			dir[x][y+1] = BAS;
			change = true;
			if (FindClosest)
			{
				int m = (toX - x)*(toX - x)+(toY - (y+1))*(toY - (y+1));
				if (m < min)
				{
					min = m;
					mindir = BAS;
				}
			}
		}
	}
	if (!change)
		return IMMOBILE;
	for (int k = 0 ; k < NBDALLEX*NBDALLEY ; k++)
	{
		change = false;
		for (int i = 1 ; i < NBDALLEX - 1 ; i++)
			for (int j = 1 ; j < NBDALLEY - 1 ; j++)
				if ((Carte[i][j] & TRAVERSABLE) && (!bombe[i][j] || isOnBombe))
				{
					bool newchange = false;
					if ((dist[i][j] != 0x01010101) && (*f)(bombe, i, j, p))
						return dir[i][j];
					if (dist[i-1][j]+1 < dist[i][j])
					{
						dist[i][j] = dist[i-1][j] + 1;
						dir[i][j] = dir[i-1][j];
						newchange = change = true;
					}
					if (dist[i+1][j]+1 < dist[i][j])
					{
						dist[i][j] = dist[i+1][j] + 1;
						dir[i][j] = dir[i+1][j];
						newchange = change = true;
					}
					if (dist[i][j+1]+1 < dist[i][j])
					{
						dist[i][j] = dist[i][j+1] + 1;
						dir[i][j] = dir[i][j+1];
						newchange = change = true;
					}
					if (dist[i][j-1]+1 < dist[i][j])
					{
						dist[i][j] = dist[i][j-1] + 1;
						dir[i][j] = dir[i][j-1];
						newchange = change = true;
					}
					if (FindClosest && newchange)
					{
						int m = (toX - i)*(toX - i)+(toY - j)*(toY - j);
						if (m < min)
						{
							min = m;
							mindir = dir[i][j];
						}
					}
				}
		if (!change)
			return mindir;
	}
	return mindir;
}

bool bFindSafeDir(char bombe[NBDALLEX][NBDALLEY], int i, int j, void *p)
{
	return !bombe[i][j];
}

char Joueur::FindSafeDir (char bombe[NBDALLEX][NBDALLEY], DWORD t)
{
	return FindDir (bombe, t, &bFindSafeDir, NULL, false, 0, 0);
}

Joueur* Joueur::FindClosest ()
{
	int dist = 0x0FFFFFFF, d;
	Joueur *min = NULL;
	for (int i = 0 ; i < nbj ; i++)
		if (j[i]->n != n && j[i]->nbre_vie)
			if ((d = ((x>>8) - (j[i]->x>>8))*((x>>8) - (j[i]->x>>8)) + ((y>>8) - (j[i]->y>>8))*((y>>8) - (j[i]->y>>8))) < dist)
			{
				dist = d;
				min = j[i];
			}
	return min;
}

bool bAttack(char bombe[NBDALLEX][NBDALLEY], int i, int j, void *p)
{
	Joueur *c = (Joueur *)p;
	return ((posjx2posc(c->x) == i && posjy2posc(c->y) == j)) || (Carte[i][j] & (SPEEDUP | FLAMMEUP));
}


char Joueur::Attack (Joueur *c, char bombe[NBDALLEX][NBDALLEY], DWORD t)
{
	if (!c)
		return IMMOBILE;

	if ((c->x>>8)/DALLEX == (x>>8)/DALLEX && (c->y>>8)/DALLEY == (y>>8)/DALLEY)
	{
		CheckBombe (bombe, t);
		return IMMOBILE;
	}

	char d = FindDir (bombe, t, &bAttack, (void *)c, true, posjx2posc(c->x), posjy2posc(c->y));
	if (d == IMMOBILE)
		CheckBombe (bombe, t);
	return d;
}

void Joueur::CheckBombe (char bombe[NBDALLEX][NBDALLEY], DWORD t)
{
	if (nb_bombe_jeu)
		return;
	int x = posjx2posc(this->x), y = posjy2posc(this->y);
	bombe[x][y] = 1;
	for (int i = 1 ; (i < lg_flamme+1) && (x+i < NBDALLEX) ; i++)
		if (Carte[x+i][y] & TRAVERSABLE)
			bombe[x+i][y] = 1;
		else
			break;
	for (i = 1 ; (i < lg_flamme+1) && (x-i >= 0) ; i++)
		if (Carte[x-i][y] & TRAVERSABLE)
			bombe[x-i][y] = 1;
		else
			break;
	for (i = 1 ; (i < lg_flamme+1) && (y+i < NBDALLEY) ; i++)
		if (Carte[x][y+i] & TRAVERSABLE)
			bombe[x][y+i] = 1;
		else
			break;
	for (i = 1 ; (i < lg_flamme+1) && (y-i < NBDALLEY) ; i++)
		if (Carte[x][y-i] & TRAVERSABLE)
			bombe[x][y-i] = 1;
		else
			break;
	if (FindDir (bombe, t, &bFindSafeDir, NULL, false, 0, 0) != IMMOBILE)
		SETKEY (buff, this->bombe);
}

void Joueur::IA (DWORD t)
{
	CLRKEY (buff, gauche);
	CLRKEY (buff, droite);
	CLRKEY (buff, bas);
	CLRKEY (buff, haut);
	CLRKEY (buff, bombe);
	char bombe[NBDALLEX][NBDALLEY];

	ZeroMemory (&bombe[0][0],sizeof (char)*NBDALLEX*NBDALLEY);
	pbombe p = lst->liste;
	while (p)
	{
		bombe[p->x][p->y] = 1;
		for (int i = 1 ; (i < p->lg_flamme+1) && (p->x+i < NBDALLEX) ; i++)
			if (Carte[p->x+i][p->y] & TRAVERSABLE)
				bombe[p->x+i][p->y] = 1;
			else
				break;
		for (i = 1 ; (i < p->lg_flamme+1) && (p->x-i >= 0) ; i++)
			if (Carte[p->x-i][p->y] & TRAVERSABLE)
				bombe[p->x-i][p->y] = 1;
			else
				break;
		for (i = 1 ; (i < p->lg_flamme+1) && (p->y+i < NBDALLEY) ; i++)
			if (Carte[p->x][p->y+i] & TRAVERSABLE)
				bombe[p->x][p->y+i] = 1;
			else
				break;
		for (i = 1 ; (i < p->lg_flamme+1) && (p->y-i < NBDALLEY) ; i++)
			if (Carte[p->x][p->y-i] & TRAVERSABLE)
				bombe[p->x][p->y-i] = 1;
			else
				break;
		p = p->suiv;
	}

	switch (bombe[(x>>8)/DALLEX][(y>>8)/DALLEY] ? FindSafeDir (bombe, t) : Attack (FindClosest (), bombe, t))
	{
	case GAUCHE:
		SETKEY (buff, gauche);
		break;
	case DROITE:
		SETKEY (buff, droite);
		break;
	case HAUT:
		SETKEY (buff, haut);
		break;
	case BAS:
		SETKEY (buff, bas);
		break;
	}
}
