#include "main.h"
#include "ddraw.h"
#include "Swap.h"
#include "DDStuff.h"
#include "Reseau.h"
#include "Son.h"
#include "Setup.h"
#include "Sprite.h"
#include "Keyb.h"

#define FADEIN		1500
#define SUSTAIN		3000
#define FADEOUT		4500
#define DECALT		300

void ClrBack ()
{
	DDBLTFX fx;
	ZeroMemory (&fx, sizeof (DDBLTFX));
	fx.dwSize = sizeof (DDBLTFX);
	lpDDSBack->Blt (NULL, NULL, NULL, DDBLT_WAIT | DDBLT_COLORFILL, &fx);
}

BOOL UpdateIntro (HWND hWnd, int elapsed_time)
{
	static t = 0;
	static int ecran2 = 0;

	if (t == 0)
	{
		LoadFond(lpDD, lpDDSFond, FondIntro);
		PlayEvent (1);
		t = 1;
	}

	t+=elapsed_time;

	UpdateKeyboard ();
	if (KEYDOWN(bufferkeyb, DIK_SPACE))
		t = FADEOUT;
	if (t < FADEIN)
	{
		ClrBack ();
		RECT r =	{long(sizeX/2*(1 - float(t+DECALT)/(FADEIN+DECALT))),
					 long(sizeY/2*(1 - float(t+DECALT)/(FADEIN+DECALT))),
					 long(sizeX/2*(1 + float(t+DECALT)/(FADEIN+DECALT)))-1,
					 long(sizeY/2*(1 + float(t+DECALT)/(FADEIN+DECALT)))-1};
		lpDDSBack->Blt(&r,lpDDSFond, NULL, DDBLT_WAIT, NULL);
		lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
		return TRUE;
	}
	if (t < SUSTAIN)
	{
		lpDDSBack->Blt(NULL,lpDDSFond, NULL, DDBLT_WAIT, NULL);
		lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
		return TRUE;
	}
	if (t < FADEOUT)
	{
		ClrBack ();
		RECT r =	{long(sizeX/2*float(t-SUSTAIN)/(FADEOUT-SUSTAIN+DECALT)),
					 long(sizeY/2*float(t-SUSTAIN)/(FADEOUT-SUSTAIN+DECALT)),
					 long(sizeX*(1 - 0.5*float(t-SUSTAIN)/(FADEOUT-SUSTAIN+DECALT)))-1,
					 long(sizeY*(1 - 0.5*float(t-SUSTAIN)/(FADEOUT-SUSTAIN+DECALT)))-1};
		lpDDSBack->Blt(&r,lpDDSFond, NULL, DDBLT_WAIT, NULL);
		lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
		return TRUE;
	}

	if (ecran2 == 0)
	{
		ecran2 = 1;
		LoadFond(lpDD, lpDDSFond, FondIntro2);
		t = 1;
		return TRUE;
	}
	if (ecran2 == 1)
		ecran2 = 2;
		
	return Swap2Play ();
}
