#include <stdio.h>
#include "ddutil.h"
#include "sprite.h"
#include "Joueur.h"
#include "Keyb.h"
#include "Bombe.h"
#include "Reseau.h"
#include "Setup.h"
#include "Son.h"
#include "Alphabet.h"
#include "Ia.h"

#define	ESPAC_AFFJ			148
#define SIZE_PTIT_JOUEUR_X	12
#define SIZE_PTIT_JOUEUR_Y	12
#define ESPACE_AFF_Y		18
#define OFFSET_Y			-5

Joueur* j[NBJMAX] = {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL};
touche tab_touche[NBJMAXLocal] = {	DIK_LEFT,	DIK_RIGHT,	DIK_UP,	DIK_DOWN,	DIK_RCONTROL,
									DIK_D,		DIK_G,		DIK_R,	DIK_F,		DIK_S,
									DIK_J,		DIK_L,		DIK_I,	DIK_K,		DIK_H,
									DIK_NUMPAD4,DIK_NUMPAD6,DIK_NUMPAD8,DIK_NUMPAD5,DIK_NUMPAD0};
touche nettab_touche[NBJMAX-1] = {	DIK_A, DIK_B, DIK_C, DIK_D, DIK_E,
									DIK_F, DIK_G, DIK_H, DIK_I, DIK_J,
									DIK_K, DIK_L, DIK_M, DIK_N, DIK_O,
									DIK_P, DIK_Q, DIK_R, DIK_S, DIK_T,
									DIK_U, DIK_V, DIK_W, DIK_X, DIK_Y,
									DIK_Z, DIK_1, DIK_2, DIK_3, DIK_4,
									DIK_5, DIK_6, DIK_7, DIK_8, DIK_9};

int startpos[NBJMAX][2] =	{1,				1,
							NBDALLEX-2,		NBDALLEY-2,
							1,				NBDALLEY-2,
							NBDALLEX-2,		1,
							1,				NBDALLEY/2-1,
							NBDALLEX-2,		NBDALLEY/2-1,
							NBDALLEX/2-1,	1,
							NBDALLEX/2-1,	NBDALLEY-2};

char playername[4][LGNAME] = {"Kill'm all", "Terminator", "Crazy Man", "Gritche"};
bool isIA[NBJMAXLocal] = {false, false, false, false};

void CreateSprSurface(LPDIRECTDRAWSURFACE &lpDDSSpr)
{
	DDSURFACEDESC ddsd;

    ZeroMemory(&ddsd, sizeof(ddsd));
    ddsd.dwSize = sizeof(ddsd);
    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	ddsd.dwWidth = SPRITEX;
	ddsd.dwHeight = SPRITEY;
    lpDD->CreateSurface(&ddsd, &lpDDSSpr, NULL);
}

int Joueur::num = 0;

Joueur::Joueur(char *filename, int dx, int dy, int g, int d, int h, int b, int bmb, int isL, int isH, char *nom_)
{
	x = int(DALLEX *(dx + 0.5))<<8;
	y = int(DALLEY * (dy + 0.5))<<8;
	couleur = 1;
	lg_flamme = 2;
	nbre_vie = 1;
	vitesse = 50;
	nb_bombe = 1;
	nb_bombe_jeu = nb_bombe_posee = 0;
	score = 0;
	Change = false;
	HasChanged = true;

	gauche = g;
	droite = d;
	haut = h;
	bas = b;
	bombe = bmb;

	isLocal = isL;
	buff = isLocal ? (isH ? bufferkeyb : vIAbufferkeyb) : vnetbufferkeyb;

	isHumain = isH;

	strcpy (nom, nom_);

	lastbmb = 0;
	lastx = 0;
	lasty = 0;

	LPDIRECTDRAWSURFACE lpDDStmp = NULL;
	lpDDStmp = DDLoadBitmap(lpDD, filename, 0, 0);
	for (int i = 0; i < NBANIM; i++)
		for (int j = 0; j < NBSPR; j++)
		{
			RECT r;
			r.left = j * (SPRITEX+1);
			r.top = i * (SPRITEY+1);
			r.right = (j+1) * (SPRITEX+1) - 1;
			r.bottom = (i+1)*(SPRITEY+1) - 1;
			lpDDSSprite[i][j] = NULL;
			CreateSprSurface(lpDDSSprite[i][j]);
			if (lpDDSSprite[i][j])
			{
				lpDDSSprite[i][j]->BltFast(0,0, lpDDStmp, &r, 0);
				DDSetColorKey(lpDDSSprite[i][j], COLORKEY);
				delai[TEMPS_RESTANT][i][j] = delai[TEMPS_SPR][i][j] = 100;
			}
		}
	dir = IMMOBILE;
	num_anim = 0;
	lpDDStmp->Release();

	if (num == 0)
		if (InitIAThread ())
			SetEvent (IAeventHandles[IA_EVENT_START]);
	n = num++;
}

Joueur::~Joueur()
{
	SetEvent (IAeventHandles[IA_EVENT_STOP]);
	for (int i = 0; i < NBANIM; i++)
		for (int j = 0; j < NBSPR; j++)
			if (lpDDSSprite[i][j])
			{
				lpDDSSprite[i][j]->Release();
				lpDDSSprite[i][j] = NULL;
			}
	num--;
	if (num == 0)
		CloseIAThread ();
}

void Joueur::Update(int t)
{
	Change = false;
	if (!nbre_vie)
		return;

	int x2,y2;
	if (KEYDOWN(buff, droite))
		x2 = x + vitesse * t;
	else if (KEYDOWN(buff, gauche))
		x2 = x - vitesse * t;
	else x2 = x;
	if (KEYDOWN(buff, haut))
		y2 = y - vitesse * t;
	else if (KEYDOWN(buff, bas))
		y2 = y + vitesse * t;
	else y2 = y;

	int xm,xd,xh,xg,xb,xhd,xhg,xbd,xbg,ym,yd,yh,yg,yb,yhd,yhg,ybd,ybg;
	xg = xhg = xbg = ((x2>>8) - SPRITEX/2)/DALLEX;
	xm = xh  = xb  = (x2>>8)/DALLEX;
	xd = xhd = xbd = ((x2>>8) + SPRITEX/2)/DALLEX;

	yh = yhg = yhd = ((y2>>8) - SPRITEY/2)/DALLEY;
	ym = yd  = yg  = (y2>>8)/DALLEY;
	yb = ybg = ybd = ((y2>>8) + SPRITEY/2)/DALLEY;


	dir = IMMOBILE;

	if (KEYDOWN(buff, droite))
	{
		dir = DROITE;
		if ((Carte[xd][yd] & TRAVERSABLE) || ((Carte[xd][yd] & BOMBE) && xd == lastx && yd == lasty))
		{
			x = x2;
			if (!(Carte[xhd][yhd] & TRAVERSABLE) || !(Carte[xbd][ybd] & TRAVERSABLE))
				y = int(((y>>8)/DALLEY + 0.5) * DALLEY)<<8;
		}
	} else
	if (KEYDOWN(buff, gauche))
	{
		dir = GAUCHE;
		if ((Carte[xg][yg] & TRAVERSABLE) || ((Carte[xg][yg] & BOMBE) && xg == lastx && yg == lasty))
		{
			x = x2;
			if (!(Carte[xhg][yhg] & TRAVERSABLE) || !(Carte[xbg][ybg] & TRAVERSABLE))
				y = int(((y>>8)/DALLEY + 0.5) * DALLEY)<<8;
		}
	}

	if (KEYDOWN(buff, haut))
	{
		dir = HAUT;
		if ((Carte[xh][yh] & TRAVERSABLE) || ((Carte[xh][yh] & BOMBE) && xh == lastx && yh == lasty))
		{
			y = y2;
			if (!(Carte[xhg][yhg] & TRAVERSABLE) || !(Carte[xhd][yhd] & TRAVERSABLE))
				x = int(((x>>8)/DALLEX + 0.5) * DALLEX)<<8;
		}
	} else
	if (KEYDOWN(buff, bas))
	{
		dir = BAS;
		if ((Carte[xb][yb] & TRAVERSABLE) || ((Carte[xb][yb] & BOMBE) && xb == lastx && yb == lasty))
		{
			y = y2;
			if (!(Carte[xbg][ybg] & TRAVERSABLE) || !(Carte[xbd][ybd] & TRAVERSABLE))
				x = int(((x>>8)/DALLEX + 0.5) * DALLEX)<<8;
		}
	}

	if (dir != IMMOBILE)
		Change = true;

	if (KEYDOWN(buff, bombe))
	{
		if (nb_bombe - nb_bombe_posee && !lastbmb && !(Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & BOMBE))
		{
			lastbmb = 1;
			lastx = (x>>8)/DALLEX;
			lasty = (y>>8)/DALLEY;
			for (int i = 0 ; i < nbj ; i++)
				if (posjx2posc(j[i]->x) == lastx && posjy2posc(j[i]->y) == lasty)
				{
					j[i]->lastx = lastx;
					j[i]->lasty = lasty;
				}
			lst->AddBombe(this);
			nb_bombe_jeu++;
			nb_bombe_posee++;
			Change = true;
		}
	}
	else
		lastbmb = 0;

	if (lastx != (x>>8)/DALLEX || lasty != (y>>8)/DALLEY)
		lasty = lastx = 0;

	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & FERMETURE)
	{
		nbre_vie = 0;
		SendAction (this, 1, -1);
	}
	int n_tue = Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] >> 24;
	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & (FLAMMEH | FLAMMEV | FLAMMEFING | FLAMMEFIND | FLAMMEFINB | FLAMMEFINH))
	{
		if (n == n_tue)
		{
			if (isLocal)
			{
				score--;
				SendAction (this, 1, -2);
			}
		}
		else
		{
			if (isLocal)
			{
				j[n_tue]->score++;
				SendAction (this, 1, n_tue);
			}
		}
		nbre_vie=0;
		PlayEvent (DEAD);
	}

	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & BOMBESUP)
	{		
		nb_bombe++;
		PlayEvent (BOMBEP);
		Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] &= ~BOMBESUP;
	}
	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & BOMBEINF)
	{	
		if (nb_bombe - 1)
		{
			PlayEvent (BOMBEM);
			nb_bombe--;
		}
		Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] &= ~BOMBEINF;
	}
	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & SPEEDUP)
	{
		if (vitesse < SPEEDMAX)
		{
			vitesse += SPEEDSTEP;
			PlayEvent (SPEEDP);
		}
		Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] &= ~SPEEDUP;
	}
	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & SPEEDDOWN)
	{
		if (vitesse > SPEEDMIN)
		{
			vitesse -= SPEEDSTEP;
			PlayEvent (SPEEDM);
		}
		Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] &= ~SPEEDDOWN;
	}
	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & FLAMMEUP)
	{		
		lg_flamme++;
		PlayEvent (FLAMMEP);
		Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] &= ~FLAMMEUP;
	}
	if (Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] & FLAMMEDOWN)
	{		
		if (lg_flamme - 1)
		{
			lg_flamme--;
			PlayEvent (FLAMMEM);
		}
		Carte[(x>>8)/DALLEX][(y>>8)/DALLEY] &= ~FLAMMEDOWN;
	}

	delai[TEMPS_RESTANT][dir][num_anim] -= t;
	if (delai[TEMPS_RESTANT][dir][num_anim] < 0)
	{
		delai[TEMPS_RESTANT][dir][num_anim] = delai[TEMPS_SPR][dir][num_anim];
		num_anim = ++num_anim % NBSPR;
	}
	if (isLocal && Change)
	{
		SendAction (this, 0, 0);
		HasChanged = true;
	}
	if (isLocal && HasChanged && !Change)
	{
		SendAction (this, 0, 0);
		HasChanged = false;
	}
}

void Joueur::Aff()
{
	if (nbre_vie)
		lpDDSBack->BltFast((x>>8) - SPRITEX/2, (y>>8) - SPRITEY/2, lpDDSSprite[dir][num_anim], NULL, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);

	char str[20];
	RECT r = {ESPAC_AFFJ*(n & 3),
		      DALLEY*NBDALLEY+ESPACE_AFF_Y*(n>>2)+OFFSET_Y,
		      ESPAC_AFFJ*(n & 3) + SIZE_PTIT_JOUEUR_X,
			  DALLEY*NBDALLEY+ESPACE_AFF_Y*(n>>2)+SIZE_PTIT_JOUEUR_Y+OFFSET_Y};
	if (nbre_vie)
		lpDDSBack->Blt (&r, lpDDSSprite[0][0], NULL, DDBLT_WAIT | DDBLT_KEYSRC, NULL);
	Affiche (ESPAC_AFFJ*(n & 3)+20, DALLEY*NBDALLEY+ESPACE_AFF_Y*(n>>2)-2, nom);
	sprintf(str, " : %d", score);
	Affiche (ESPAC_AFFJ*(n & 3)+20+CHARX*(strlen(nom)+1), DALLEY*NBDALLEY+ESPACE_AFF_Y*(n>>2)-2, str);
}

void CreateJoueur ()
{
	int local = 0, net = 0;
	if (reseau_enabled)
	{
		for (int i = 0 ; i < nbj ; i++)
		{
			bool l;
			l = false;
			for (int n = 0 ; n < NBJLocal ; n++ )
				if (IDPlayer[i] == dpPlayerID[n])
				{
					j[i] = new Joueur(SpriteBmp[i], startpos[i][0],startpos[i][1],tab_touche[local].gauche, tab_touche[local].droite, tab_touche[local].haut, tab_touche[local].bas, tab_touche[local].bombe, 1, isIA[local] ? 0 : 1, PlayerName[i]);
					local++;
					l = true;
					break;
				}
			if (!l)
			{
				j[i] = new Joueur(SpriteBmp[i], startpos[i][0],startpos[i][1],nettab_touche[net].gauche, nettab_touche[net].droite, nettab_touche[net].haut, nettab_touche[net].bas, nettab_touche[net].bombe, 0, 1, PlayerName[i]);
				net++;
			}
		}
	}
	else
	{
		for (int i = 0 ; i < nbj ; i++)
		{
			j[i] = new Joueur(SpriteBmp[i], startpos[i][0],startpos[i][1],tab_touche[local].gauche, tab_touche[local].droite, tab_touche[local].haut, tab_touche[local].bas, tab_touche[local].bombe, 1, isIA[local] ? 0 : 1, playername [i]);
			local++;
		}
	}
}