#include "Windows.h"
#include "DDraw.h"
#include "DDutil.h"
#include "Reseau.h"
#include "Setup.h"
#include "cpt_rebours.h"
#include "Map.h"
#include "Son.h"
#include "Main.h"
#include "Sprite.h"
#include "Swap.h"

#define SPRWINNERX		100
#define SPRWINNERY		300
#define	SPRWINNERH		50
#define SPRWINNERW		50

BOOL Swap2Play ()
{
	LoadFond(lpDD, lpDDSFond, FondF);
	if (reseau_enabled)
	{
		mode = INITGAME;
		return TRUE;
	}

	LoadSprite();
	PlayEvent (STARTPLAY);
	mode = JEU;
	PlayEvent (MUSIC);
	return TRUE;
}

void AffWinners ()
{
	int maxs = 0;
	RECT r = {SPRWINNERX, SPRWINNERY, SPRWINNERX + SPRWINNERW, SPRWINNERY + SPRWINNERH};

	for (int i = 0 ; i < nbj ; i++)
		if (j[i]->score > maxs)
			maxs = j[i]->score;
	for (i = 0 ; i < nbj ; i++)
		if (j[i]->score == maxs)
		{
			lpDDSBack->Blt (&r, j[i]->lpDDSSprite[0][0], NULL, DDBLT_WAIT | DDBLT_KEYSRC, NULL);
			r.right += SPRWINNERW;
			r.left +=  SPRWINNERW;
		}
}

BOOL Swap2GameOver ()
{
	PlayEvent (GAME_OVER);
	for (int i = 0 ; i < nbj ; i++)
		j[i]->Aff();
	LoadFond(lpDD, lpDDSFond, FondGameOver);
	DDSetColorKey(lpDDSFond, COLORKEY);
	lpDDSBack->BltFast(0, 0, lpDDSFond, NULL, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
	AffWinners ();
	lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
	start = PLAYAGAIN-1;
	mode = GAMEOVER;
	return TRUE;
}

BOOL Swap2PlayAgain ()
{
	PlayEvent (STARTPLAY);
	LoadFond(lpDD, lpDDSFond, FondF);
	AffFond(lpDDSBack, lpDDSFond);
	lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
	if (reseau_enabled)
	{
		if (isHost)
		{
			LoadCarte("map\\map1.map");
			PlayAgain ();
			mode = INITGAME;
			return TRUE;
		}
		else
		{
			mode = INITGAME;
			return TRUE;
		}
	}

	LoadSprite();
	PlayEvent (MUSIC);
	LoadCarte("map\\map1.map");
	mode = JEU;
	return TRUE;
}

void Swap2End ()
{
	mode = END;
	LoadFond(lpDD, lpDDSFond, FondEnd);
	lpDDSBack->BltFast(0, 0, lpDDSFond, NULL, DDBLTFAST_WAIT);
	lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
}
