#include "Windows.h"
#include "Update.h"
#include "Swap.h"
#include "Main.h"
#include "Reseau.h"
#include "Setup.h"
#include "Keyb.h"
#include "Cpt_rebours.h"
#include "Sprite.h"
#include "Map.h"
#include "Intro.h"
#include "IA.h"
#include "Son.h"

#define END_TIME	15000

BOOL Update(HWND hWnd)
{
	static DWORD t_last = GetTickCount();
	int elapsed_time = GetTickCount() - t_last;
	t_last = GetTickCount();

	if (elapsed_time == 0)
		return TRUE;

	switch (mode)
	{
	case INTRO :
		return UpdateIntro (hWnd, elapsed_time);
	case GAMEOVER:
		return UpdateGameOver (hWnd, elapsed_time);
	case JEU:
		return UpdatePlay (hWnd, elapsed_time);
	case END:
		return UpdateEnd (hWnd, elapsed_time);
	case WAITING_READY:
		return UpdateWaitingReady(hWnd, elapsed_time);
	case WAITING_START:
		return UpdateWaitingStart(hWnd, elapsed_time);
	case INITGAME:
		return UpdateInitGame(hWnd, elapsed_time);
	}
	return FALSE;
}

void CheckWinner ()
{
	if (cheatmode)
		return;
	int alive = 0;
	for (int i = 0 ; i < nbj ; i++)
		if (j[i]->nbre_vie)
			alive++;
	if (alive <= 1 && cpt_->cpt > 1)
		cpt_->cpt = 1;
}

BOOL UpdatePlay (HWND hWnd, int elapsed_time)
{
	if (cpt_->cpt > 0)
	{
		if (!IA_is_waiting)
			return TRUE;
		AffFond(lpDDSBack, lpDDSFond);
		DrawOption();
		for (int i=0; i < nbj ; i++)
		{
			j[i]->Update(elapsed_time);
			j[i]->Aff();
		}
		SetEvent (IAeventHandles[IA_EVENT_IA]);
		lst->Update(elapsed_time);
		lst->Aff();
		cpt_->Update(elapsed_time);
		cpt_->Aff();
		lpDDSPrimary->Flip(NULL, DDFLIP_WAIT);
		UpdateKeyboard();
		CheckWinner ();
	} else
	{
		Swap2GameOver ();
	}
	return TRUE;
}

BOOL UpdateGameOver (HWND hWnd, int elapsed_time)
{
	UpdateKeyboard ();
	if (reseau_enabled && !isHost && (KEYDOWN(bufferkeyb, DIK_SPACE)))
		SendQueryPlayAgain();
	if ((KEYDOWN(bufferkeyb, DIK_SPACE) && (!reseau_enabled || isHost )) || (start == PLAYAGAIN) || (start == SENDREADY) )
		Swap2PlayAgain();
	return TRUE;
}

BOOL UpdateEnd (HWND hWnd, int elapsed_time)
{
	static t = 0;
	static end = 0;

	t+= elapsed_time;
	UpdateKeyboard ();
	if (KEYDOWN(bufferkeyb, DIK_SPACE))
		t = END_TIME;
	if ( t >= END_TIME && !end)
	{
		end = 1;
		PostMessage(hWnd, WM_CLOSE, 0, 0);
	}
	return TRUE;
}


void EndInitGame()
{
	LoadSprite();
	PlayEvent (STARTPLAY);
	PlayEvent (MUSIC);
}

BOOL UpdateWaitingReady(HWND hWnd, int elapsed_time)
{
	if (ready != nbj)
		return TRUE;
	StartPlay();
	EndInitGame();
	mode = JEU;
	return TRUE;
}

BOOL UpdateWaitingStart(HWND hWnd, int elapsed_time)
{
	if (start != START2)
		return TRUE;
	mode = JEU;
	return TRUE;
}

BOOL UpdateInitGame(HWND hWnd, int elapsed_time)
{
	if (isHost)
	{
		SendTime (initime);
		SendMap ();
		SendPlayerNum ();
		ready = NBJLocal;
		SendReady();
		mode = WAITING_READY;
	}
	else
	{
		if (start != SENDREADY)
			return TRUE;
		EndInitGame();
		for (int i = 0 ; i < NBJLocal ; i++)
			Ready();
		mode = WAITING_START;
	}

	return TRUE;
}