
#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include "resource.h"
#include "main.h"
#include "ddstuff.h"
#include "joueur.h"
#include "dplay.h"
#include "setup.h"
#include "reseau.h"
#include "keyb.h"
#include "bombe.h"
#include "DPlayStuff.h"
#include "Swap.h"

DPID                dpPlayerID[NBJMAXLocal];				// ID du joueur local
DPID				IDPlayer[NBJMAX];
char				PlayerName[NBJMAX][LGNAME];
int					nbj = 1;
int					isHost = 0;
int					start = 0;
int					ready = 0;
int					parti = 0;

void ChatterAddPlayer( LPSTR szPlayerName, DPID pidID, HWND hWnd )
{
	if (!isHost)
		return;

	for (int i = 0 ; i< nbj ; i++)							// le 1er joueur recoit message creation autres
		if (IDPlayer[i] == pidID)
			return;
	if (AcceptingPlayers)
	{
		strncpy(PlayerName[nbj], szPlayerName, LGNAME);
		IDPlayer[nbj++] = pidID;
	}
	else
		lpDP->DestroyPlayer (pidID);
}

void ChatterDeletePlayer( LPSTR szPlayerName, DPID pidID, HWND hWnd )
{
	if (!isHost)
		return;
	parti++;		// pb si tentative de connexion pdt jeu rejetee
}

void EvaluateChatterMessage( DPMSG_GENERIC *pGeneric, DPID pidFrom, HWND hWnd )
{   
	switch (*((int*)pGeneric))
	{
	case START:
		start = START;
		break;
	case READY:
		ready++;
		break;
	case MAP:
		ReceiveMap ( (void *)pGeneric);
		break;
	case PLAYER:
		ReceiveAction ( (void *)pGeneric);
		break;
	case ASSIGNNUM:
		ReceivePlayerNum ( (void *)pGeneric);
		break;
	case START2:
		start = START2;
		break;
	case PLAYAGAIN:
		start = PLAYAGAIN;
		break;
	case BOMB:
		ReceiveBombe ((void *)pGeneric);
		break;
	case TIME:
		ReceiveTime ((void *)pGeneric);
		break;
	case SENDREADY:
		start = SENDREADY;
		break;
	case QUERYPLAYAGAIN:
		if (isHost)
			start = PLAYAGAIN;
		break;
	}
}

int Init_Reseau (HWND hWnd)
{
    BOOL                rc;
    DWORD               dwDataSize;

    // Appelle le dialogue pour crer une connexion.
    rc = DialogBox(hInst, MAKEINTRESOURCE(IDD_CONNECT), hWnd, (DLGPROC)DlgProcDPStart );

    if ( !rc )
        return FALSE;

    // Obtient les capacits de la session.
    ZeroMemory( &dpCaps, sizeof( dpCaps ) );
    dpCaps.dwSize = sizeof( dpCaps );
    lpDP->GetCaps( &dpCaps, 0 );

    // Obtient la description de la session.
    lpDP->GetSessionDesc( NULL, &dwDataSize );
    lpdpDesc = (LPDPSESSIONDESC2) malloc( dwDataSize );
    lpDP->GetSessionDesc( lpdpDesc, &dwDataSize );

    // Laisse l'utilisateur savoir ce qui est arriv, en consultant 
    // la structure de description de la session.

	isHost = dpCaps.dwFlags & DPCAPS_ISHOST;

    // Lance le thread de rception.

    hKillEvent = CreateEvent( NULL, FALSE, FALSE, NULL );
    hReceiveThread = CreateThread( NULL,0,ReceiveThread,hWnd,0,&idReceiveThread );
    return TRUE;
}

void Quitter_Reseau ()
{
	if (reseau_enabled)
	{
		for (int i = 0 ; i < NBJLocal ; i++)
			lpDP->DestroyPlayer(dpPlayerID[i]);
		// Signale vnement pour tuer thread de rception.
		SetEvent( hKillEvent );
		// Attend l'arrt du thread.
		WaitForSingleObject( hReceiveThread, INFINITE );

		CloseHandle( hReceiveThread);               
		CloseHandle( hPlayerEvent );
		CloseHandle( hKillEvent );

		// Libre le tampon de rception.
		GlobalFreePtr( lpReceiveBuffer );
	}
	if ( lpDP != NULL )
	{
		lpDP->Release();
		lpDP = NULL;
	}
}

BOOL CreatePlayers ()
{
	DPNAME dpn;
	ZeroMemory (&dpn, sizeof (DPNAME));
	dpn.dwSize = sizeof (DPNAME);

	for (int i = 0 ; i < NBJLocal ; i++)
	{
		dpn.lpszShortNameA = playername[i];
        if ( FAILED( lpDP->CreatePlayer( &dpPlayerID[i], &dpn, hPlayerEvent, NULL, 0, 0 ) ) )
        {         
            MessageBox( NULL, "Impossible de crer joueur !", "Erreur", MB_OK );
            return FALSE;
        }
		IDPlayer[i] = dpPlayerID[i];
		strcpy(PlayerName[i], playername[i]);
	}
	ready = nbj = NBJLocal;	
	return TRUE;
}

struct Map {
	int type;
	int l;
	DWORD map[NBDALLEY];
};

void SendMap()
{
	if (!reseau_enabled)
		return;
	Map pack;

	pack.type = MAP;
	for (int i = 0 ; i < NBDALLEX ; i++)
	{
		pack.l = i;
		for (int j = 0 ; j < NBDALLEY ; j++)
			pack.map[j] = Carte[i][j];
		lpDP->Send( dpPlayerID[0], DPID_ALLPLAYERS, 0,&pack, sizeof (Map) );
	}
}

void ReceiveMap (void *m)
{
	if (isHost)
		return;
	Map *pack = (Map *)m;

	for (int j = 0 ; j < NBDALLEY ; j++)
			Carte[pack->l][j] = pack->map[j];
}

struct NumPack {
	int type;
	int nbj;
	DPID IDPlayer[NBJMAX];
	char PlayerName[NBJMAX][LGNAME];
};

void SendPlayerNum ()
{
	NumPack pack;
	memcpy(pack.IDPlayer, IDPlayer, sizeof(DPID)*NBJMAX);
	memcpy(pack.PlayerName, PlayerName, sizeof(char)*NBJMAX*LGNAME);
	pack.type = ASSIGNNUM;
	pack.nbj = nbj;
	lpDP->Send( dpPlayerID[0], DPID_ALLPLAYERS, 0,&pack, sizeof (NumPack) );
}

void ReceivePlayerNum (void *tab)
{
	if (isHost)
		return;
	NumPack *pack = (NumPack *)tab;
	memcpy (IDPlayer, pack->IDPlayer, sizeof(DPID)*NBJMAX);
	memcpy(PlayerName, pack->PlayerName, sizeof(char)*NBJMAX*LGNAME);
	nbj = pack->nbj;
}

struct JPack {
	int type;
	int num;
	int x,y;
	int g,d,b,h;
	int nb_vies;
	int killedby;
};

void SendAction (Joueur *j_, int dead, int killedby)
{
	if (!reseau_enabled)
		return;

	JPack pack;

	if (dead || j_->HasChanged)
	{
		pack.type = PLAYER;
		pack.num = j_->n;
		pack.x = j_->x;
		pack.y = j_->y;
		pack.g = KEYDOWN(bufferkeyb, j_->gauche);
		pack.d = KEYDOWN(bufferkeyb, j_->droite);
		pack.b = KEYDOWN(bufferkeyb, j_->bas);
		pack.h = KEYDOWN(bufferkeyb, j_->haut);
		pack.nb_vies = j_->nbre_vie;
		pack.killedby = dead ? killedby : -1;
		lpDP->Send( dpPlayerID[0], DPID_ALLPLAYERS, 0,&pack, sizeof (JPack) );
	}
}

void ReceiveAction (void *player)
{
	JPack *pj = (JPack *)player;

	if (!j[pj->num])
		return;

	j[pj->num]->x = pj->x;
	j[pj->num]->y = pj->y;
	j[pj->num]->nbre_vie = pj->nb_vies;
	if (pj->g)
		SETKEY(vnetbufferkeyb,j[pj->num]->gauche);
	else
		CLRKEY(vnetbufferkeyb,j[pj->num]->gauche);
	if (pj->d)
		SETKEY(vnetbufferkeyb,j[pj->num]->droite);
	else
		CLRKEY(vnetbufferkeyb,j[pj->num]->droite);
	if (pj->b)
		SETKEY(vnetbufferkeyb,j[pj->num]->bas);
	else
		CLRKEY(vnetbufferkeyb,j[pj->num]->bas);
	if (pj->h)
		SETKEY(vnetbufferkeyb,j[pj->num]->haut);
	else
		CLRKEY(vnetbufferkeyb,j[pj->num]->haut);
	switch (pj->killedby)
	{
	case -1 :
		break;
	case -2 :
		if (j[pj->num])
			j[pj->num]->score--;
		break;
	default:
		if (j[pj->killedby])
			j[pj->killedby]->score++;
		break;
	}
}

void Ready ()
{
	int i = READY;
	lpDP->Send( dpPlayerID[0], DPID_ALLPLAYERS , 0,&i, sizeof(int) );
}

void Start ()
{
	int i = START;
	lpDP->Send( dpPlayerID[0],DPID_ALLPLAYERS , 0,&i, sizeof(int) );
}

void StartPlay ()
{
	int i = START2;
	lpDP->Send( dpPlayerID[0],DPID_ALLPLAYERS , 0,&i, sizeof(int) );
}

void PlayAgain ()
{
	int i = PLAYAGAIN;
	lpDP->Send( dpPlayerID[0],DPID_ALLPLAYERS , 0,&i, sizeof(int) );
}

void SendReady()
{
	int i = SENDREADY;
	lpDP->Send( dpPlayerID[0],DPID_ALLPLAYERS , 0,&i, sizeof(int) );
}

void SendQueryPlayAgain()
{
	int i = QUERYPLAYAGAIN;
	lpDP->Send( dpPlayerID[0],DPID_ALLPLAYERS , 0,&i, sizeof(int) );
}


struct BombePack {
	int type;
	bombe b;
};

void SendBombe (bombe *b)
{
	if (!reseau_enabled)
		return;

	BombePack sb;

	sb.type = BOMB;
	memcpy (&sb.b, b, sizeof (bombe));
	lpDP->Send( dpPlayerID[0],DPID_ALLPLAYERS , 0,&sb, sizeof(BombePack) );
}

void ReceiveBombe (void *b)
{
	if (!lst)
		return;
	lst->AddBombe (&((BombePack *)b)->b);
}

struct TimePack {
	int type;
	int t;
};

void SendTime (int t)
{
	TimePack pack;
	pack.type = TIME;
	pack.t = t;
	lpDP->Send( dpPlayerID[0], DPID_ALLPLAYERS, 0,&pack, sizeof (TimePack) );
}

void ReceiveTime (void *p)
{
	if (isHost)
		return;
	TimePack *pack = (TimePack *)p;
	initime = pack->t;
}

