#include "main.h"
#include "son.h"
#include "wave.h"
#include "ddstuff.h"

LPDIRECTSOUNDBUFFER	lpdsb[NBEVENTS] = { NULL,
										NULL,
										NULL,
										NULL,
										NULL,
										NULL,
										NULL,
										NULL};
char SoundFName[NBEVENTS][20] = {	"Wav\\music.wav",
									"Wav\\bombe.wav",
									"Wav\\bombep.wav",
									"Wav\\bombem.wav",
									"Wav\\speedp.wav",
									"Wav\\speedm.wav",
									"Wav\\flammep.wav",
									"Wav\\flammem.wav",
									"Wav\\dead.wav",
									"Wav\\gameover.wav",
									"Wav\\Tada.wav",
									"Wav\\Alerte.wav"};

BOOL LoadWave(LPSTR lpzFileName, LPDIRECTSOUNDBUFFER &lpdsb_)
{
	HMMIO                   hmmio;
	MMCKINFO                mmckinfoData, mmckinfoParent;
	WAVEFORMATEX            *pwfx = NULL;

	if (lpdsb_ != NULL)
		{
			lpdsb_->Release();
			lpdsb_ = NULL;
		}
 
    if (WaveOpenFile(lpzFileName, &hmmio, &pwfx, &mmckinfoParent) != 0)
        return FALSE;
    if (WaveStartDataRead(&hmmio, &mmckinfoData, &mmckinfoParent) != 0)
        return FALSE;

    memset(&dsbdesc, 0, sizeof(DSBUFFERDESC)); 
    dsbdesc.dwSize = sizeof(DSBUFFERDESC); 
    dsbdesc.dwFlags = DSBCAPS_GETCURRENTPOSITION2   // Always a good idea
					| DSBCAPS_GLOBALFOCUS;         // Allows background playing
 
    dsbdesc.dwBufferBytes = mmckinfoData.cksize;
    dsbdesc.lpwfxFormat = pwfx; 
 
    if FAILED(lpds->CreateSoundBuffer(&dsbdesc, &lpdsb_, NULL))
    {
        WaveCloseReadFile(&hmmio, &pwfx);
        return FALSE; 
    }
 
    LONG            lNumToWrite;
    DWORD           dwStartOfs;
    VOID            *lpvPtr1, *lpvPtr2;
    DWORD           dwBytes1, dwBytes2;
    UINT            cbBytesRead;

    dwStartOfs = 0;
    lNumToWrite = dsbdesc.dwBufferBytes;
    lpdsb_->Lock(     dwStartOfs,       // Offset of lock start
                     lNumToWrite,      // Number of bytes to lock
                     &lpvPtr1,         // Address of lock start
                     &dwBytes1,        // Count of bytes locked
                     &lpvPtr2,         // Address of wrap around
                     &dwBytes2,        // Count of wrap around bytes
                     0);               // Flags
 
    WaveReadFile(hmmio,                // File handle
                 dwBytes1,             // Number of bytes to get
                 (BYTE *) lpvPtr1,     // Destination   
                 &mmckinfoData,        // File chunk info 
                 &cbBytesRead);        // Actual bytes read
 
    if (cbBytesRead < dwBytes1)        // Reached end of file
    {
        FillMemory((PBYTE)lpvPtr1 + cbBytesRead,
                dwBytes1 - cbBytesRead, 
                (dsbdesc.lpwfxFormat->wBitsPerSample==8) ? 128 : 0);
    }
	WaveCloseReadFile(&hmmio, &pwfx);
 
    lpdsb_->Unlock(lpvPtr1, dwBytes1, lpvPtr2, dwBytes2);

    return TRUE;
}

bool LoadSounds ()
{
	for (int i = 0 ; i < NBEVENTS ; i++)
//		if (!LoadWave (SoundFName[i], lpdsb[i]))
//			return false;
		LoadWave (SoundFName[i], lpdsb[i]);
	return true;
}

void PlayEvent (int n)
{
	if (Sound && n >= 0 && n < NBEVENTS && lpdsb[n])
	{
		lpdsb[n]->SetCurrentPosition (0);
		lpdsb[n]->Play(0, 0, n == MUSIC ? DSBPLAY_LOOPING : 0);
	}
}
